var NUM_USER_IMAGES, get, getRoom, ready, view, _ref;
_ref = require('derby').createApp(module), get = _ref.get, view = _ref.view, ready = _ref.ready;
NUM_USER_IMAGES = 10;
get('/:room?', function(page, model, _arg) {
  var room, userId, _room;
  room = _arg.room;
  if (!(room && /^[-\w ]+$/.test(room))) {
    return page.redirect('/lobby');
  }
  _room = room.toLowerCase().replace(/[_ ]/g, '-');
  if (_room !== room) {
    return page.redirect("/" + _room);
  }
  if (userId = model.get('_session.userId')) {
    return getRoom(page, model, room, userId);
  }
  return model.async.incr('nextUserId', function(err, userId) {
    model.set('_session.userId', userId);
    model.set("users." + userId, {
      name: 'User ' + userId,
      picClass: 'pic' + (userId % NUM_USER_IMAGES)
    });
    return getRoom(page, model, room, userId);
  });
});
getRoom = function(page, model, room, userId) {
  return model.subscribe({
    _room: "rooms." + room
  }, 'users', function() {
    model.setNull('_room.messages', []);
    model.set('_user', model.ref("users." + userId));
    model.set('_newComment', '');
    model.set('_numMessages', model.get('_room.messages').length);
    return page.render();
  });
};
view.after('message', function() {
  return $('messages').scrollTop = $('messageList').offsetHeight;
});
ready(function(model) {
  model.set('_showReconnect', true);
  exports.connect = function() {
    model.set('_showReconnect', false);
    setTimeout((function() {
      return model.set('_showReconnect', true);
    }), 1000);
    return model.socket.socket.connect();
  };
  exports.reload = function() {
    return window.location.reload();
  };
  model.on('push', '_room.messages', function() {
    return model.incr('_numMessages');
  });
  return exports.postMessage = function() {
    model.push('_room.messages', {
      userId: model.get('_session.userId'),
      comment: model.get('_newComment')
    });
    return model.set('_newComment', '');
  };
});