var attr, comment, empty, endTag, literalEnd, literalTag, startTag, uncomment;
startTag = /^<([^\s=\/>]+)((?:\s+[^\s=\/>]+(?:\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|[^>\s]+)?)?)*)\s*(\/?)\s*>/;
endTag = /^<\/([^\s=\/>]+)[^>]*>/;
attr = /([^\s=]+)(?:\s*(=)\s*(?:(?:"((?:\\.|[^"])*)")|(?:'((?:\\.|[^'])*)')|([^>\s]+))?)?/g;
literalTag = /^(?:[^:]+:|style|script)$/i;
literalEnd = function(tagName) {
  switch (tagName.toLowerCase()) {
    case 'style':
      return /<\/style/i;
    case 'script':
      return /<\/script/i;
    default:
      return /<\/?[^\s=\/>:]+:/;
  }
};
comment = /<!--[\s\S]*?-->/g;
exports.uncomment = uncomment = function(html) {
  return html.replace(comment, '');
};
empty = function() {};
exports.parse = function(html, handler) {
  var chars, charsHandler, endHandler, index, last, match, onChars, parseEndTag, parseStartTag, startHandler, tagName, _results;
  if (handler == null) {
    handler = {};
  }
  charsHandler = handler.chars || empty;
  startHandler = handler.start || empty;
  endHandler = handler.end || empty;
  parseStartTag = function(tag, tagName, rest) {
    var attrs;
    attrs = {};
    rest.replace(attr, function(match, name, equals, attr0, attr1, attr2) {
      return attrs[name.toLowerCase()] = attr0 || attr1 || attr2 || (equals ? '' : null);
    });
    return startHandler(tag, tagName.toLowerCase(), attrs);
  };
  parseEndTag = function(tag, tagName) {
    return endHandler(tag, tagName.toLowerCase());
  };
  onChars = function(html, index, literal) {
    var text;
    if (~index) {
      text = html.substring(0, index);
      html = html.substring(index);
    } else {
      text = html;
      html = '';
    }
    if (text) {
      charsHandler(text, literal);
    }
    return html;
  };
  html = uncomment(html);
  _results = [];
  while (html) {
    last = html;
    chars = true;
    if (html[0] === '<') {
      if (html[1] === '/') {
        if (match = html.match(endTag)) {
          html = html.substring(match[0].length);
          match[0].replace(endTag, parseEndTag);
          chars = false;
        }
      } else {
        if (match = html.match(startTag)) {
          html = html.substring(match[0].length);
          match[0].replace(startTag, parseStartTag);
          chars = false;
          if (literalTag.test(tagName = match[1])) {
            index = html.search(literalEnd(tagName));
            html = onChars(html, index, true);
          }
        }
      }
    }
    if (chars) {
      index = html.indexOf('<');
      html = onChars(html, index);
    }
    _results.push((function() {
      if (html === last) {
        throw 'HTML parse error: ' + html;
      }
    })());
  }
  return _results;
};